/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 8; tab-width: 8 -*- */

/*
 * Nautilus
 *
 * Copyright (C) 2010 ammonkey
 *
 * Nautilus is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * Nautilus is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; see the file COPYING.  If not,
 * write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * Author: ammonkey <am.monkeyd@gmail.com>
 */

#ifndef __NAUTILUS_FILTER_BAR_H
#define __NAUTILUS_FILTER_BAR_H

#include <gtk/gtk.h>

G_BEGIN_DECLS

#define NAUTILUS_TYPE_FILTER_BAR                (nautilus_filter_bar_get_type ())
#define NAUTILUS_FILTER_BAR(obj)                (G_TYPE_CHECK_INSTANCE_CAST ((obj), NAUTILUS_TYPE_FILTER_BAR, NautilusFilterBar))
#define NAUTILUS_FILTER_BAR_CLASS(klass)        (G_TYPE_CHECK_CLASS_CAST ((klass), NAUTILUS_TYPE_FILTER_BAR, NautilusFilterBarClass))
#define NAUTILUS_IS_FILTER_BAR(obj)             (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NAUTILUS_TYPE_FILTER_BAR))
#define NAUTILUS_IS_FILTER_BAR_CLASS(klass)     (G_TYPE_CHECK_CLASS_TYPE ((klass), NAUTILUS_TYPE_FILTER_BAR))
#define NAUTILUS_FILTER_BAR_GET_CLASS(obj)      (G_TYPE_INSTANCE_GET_CLASS ((obj), NAUTILUS_TYPE_FILTER_BAR, NautilusFilterBarClass))

typedef struct NautilusFilterBarPrivate NautilusFilterBarPrivate;

typedef struct
{
        GtkHBox box;
        NautilusFilterBarPrivate *priv;
} NautilusFilterBar;

typedef struct {
	GtkHBoxClass parent_class;

	/* signals */
	void         (* time_period_changed) (NautilusFilterBar *bar, gint idx);
	/*void         (* location_changed) (NautilusFilterBar *bar,
					   const char            *location);
	void         (* cancel)           (NautilusFilterBar *bar);*/

	/* virtual methods */
	/*void	     (* activate)	  (NautilusFilterBar *bar);
	char *       (* get_location)     (NautilusFilterBar *bar);
	void         (* set_location)     (NautilusFilterBar *bar,
					   const char            *location);*/

} NautilusFilterBarClass;

GType           nautilus_filter_bar_get_type            (void);
GtkWidget       *nautilus_filter_bar_new                (void);
gint            nautilus_filter_bar_get_period          (NautilusFilterBar *bar);
void            nautilus_filter_bar_set_period          (NautilusFilterBar *bar, gint days);

//void            nautilus_filter_bar_button_append       (GtkWidget *hbox, gchar *label, gchar *interpretation);

/*void	nautilus_navigation_bar_activate	 (NautilusFilterBar *bar);
char *  nautilus_navigation_bar_get_location     (NautilusFilterBar *bar);
void    nautilus_navigation_bar_set_location     (NautilusFilterBar *bar,
						  const char            *location);*/

G_END_DECLS

#endif /* __NAUTILUS_FILTER_BAR_H */
